require 'uu/os/rest/dto'

module UU
  module OS
    module Env
      module Process

        # Message sent by process.
        class ProcessMessage < UU::OS::REST::DTO

          # Message code.
          # @param [String]
          # @return [String]
          attr_accessor :code

          # Message text.
          # @param [String]
          # @return [String]
          attr_accessor :message

          # Message parameters.
          # @param [Array<Object>]
          # @return [Array<Object>]
          attr_accessor :parameters

          def code
            attributes[:code]
          end

          def code=(val)
            attributes[:code] = val
          end

          def message
            attributes[:message]
          end

          def message=(val)
            attributes[:message] = val
          end

          def parameters
            attributes[:parameters]
          end

          def parameters=(*val)
            attributes[:parameters] = val
          end

          # @see UU::OS::REST::DTO
          # @private
          def handle_custom_init_data(init_data, error)
            # Message can be constructed using only String
            if init_data.kind_of?String
              self.message = init_data
            else
              # Other inputs are not acceptable
              raise error
            end
          end

        end

      end
    end
  end
end
